package compbio.controllers;

import java.util.Calendar;
import java.util.Map;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import compbio.cassandra.CassandraRemover;

/**
 * @author Alexander Sherstnev
 * @author Natasha Sherstneva
 */
@Controller
public class DatabaseController extends BasicController {

	@RequestMapping(value = "/database/remove", method = RequestMethod.GET)
	public String initRemoveForm(Map<String, Object> model) {
		model.put("username", getPrincipalName());
		Calendar cal = Calendar.getInstance();
		String date2 = cal.get(Calendar.YEAR) + "/" + (cal.get(Calendar.MONTH) + 1) + "/" + cal.get(Calendar.DATE);
		cal.add(Calendar.DATE, -3);
		String date1 = cal.get(Calendar.YEAR) + "/" + (cal.get(Calendar.MONTH) + 1) + "/" + cal.get(Calendar.DATE);
		String jobid = "jp_NzBOJKo";

		model.put("samplejobid", jobid);
		model.put("date1", date1);
		model.put("date2", date2);
		model.put("sampleip", "127.0.0.1");
		model.put("sampleseq", "ATA");
		return "query/RemoveJobs";
	}

	@RequestMapping(value = "/database/state", method = RequestMethod.GET)
	public String initDBStatRequest(Map<String, Object> model) {
		model.put("username", getPrincipalName());
		// return "queryDBState";
		return "support/Denied";
	}

	@RequestMapping(value = "/database/remove/goreal", method = RequestMethod.GET)
	public String findIPwithCounter(@RequestParam("byId") String flagId, @RequestParam("id") String jobId,
			@RequestParam("byDate") String flagDate, @RequestParam("date1") String date1, @RequestParam("date2") String date2,
			@RequestParam("byIp") String flagIp, @RequestParam("ip") String ip, @RequestParam("bySequence") String flagSeq,
			@RequestParam("seq") String seq, Map<String, Object> model) {
		model.put("username", getPrincipalName());
		CassandraRemover cr = new CassandraRemover();
		int numberRemover = 0;
		if (flagId != null)
			numberRemover = cr.RemoveJobById(jobId);
		if (flagDate != null)
			numberRemover = cr.RemoveJobByDate(date1, date2);
		if (flagIp != null)
			numberRemover = cr.RemoveJobByIp(ip);
		if (flagSeq != null)
			numberRemover = cr.RemoveJobBySequence(seq);
		model.put("result", numberRemover);
		return "reportRemoveData";
	}

	@RequestMapping(value = "/database/remove/go", method = RequestMethod.GET)
	public String findIPwithCounter(@RequestParam("id") String jobId, @RequestParam("date1") String date1,
			@RequestParam("date2") String date2, @RequestParam("ip") String ip, @RequestParam("seq") String seq, Map<String, Object> model) {
		model.put("username", getPrincipalName());
		/*
		 * CassandraRemover cr = new CassandraRemover(); int numberRemover = 0;
		 * if (flagId != null) numberRemover = cr.RemoveJobById(jobId); if
		 * (flagDate != null) numberRemover = cr.RemoveJobByDate(date1, date2);
		 * if (flagIp != null) numberRemover = cr.RemoveJobByIp(ip); if (flagSeq
		 * != null) numberRemover = cr.RemoveJobBySequence(seq);
		 * model.put("result", numberRemover); return "reportRemoveData";
		 */
		return "support/Blocked";
	}

}
